package ru.dbotthepony.mc.otm.client.screen.panels.input

import net.minecraft.client.gui.screens.Screen
import ru.dbotthepony.mc.otm.client.screen.panels.EditablePanel
import ru.dbotthepony.mc.otm.menu.input.AbstractNetworkedInput
import ru.dbotthepony.mc.otm.milliTime

open class NetworkedStringInputPanel<out S : Screen>(
	screen: S,
	parent: EditablePanel<*>?,
	val backend: AbstractNetworkedInput<String>,
	x: Float = 0f,
	y: Float = 0f,
	width: Float = 60f,
	height: Float = 11f,
) : TextInputPanel<S>(screen, parent, x, y, width, height) {
	override var isActive: Boolean
		get() = backend.check()
		set(value) {}

	override fun onFocusChanged(new: Boolean, old: Boolean) {
		super.onFocusChanged(new, old)

		if (new && !backend.check()) {
			killFocus()
		}
	}

	private var lastChanges = 0L

	override fun onTextChanged(old: String, new: String) {
		lastChanges = milliTime + 1000L
		backend.input(new)
	}

	override fun tick() {
		super.tick()

		if (milliTime >= lastChanges) {
			text = backend.value
		}
	}
}
